#include "Info.h"

template<typename T,
	typename = typename std::enable_if<std::is_base_of<VarInfo, T>::value>::type,
	typename TPtr = shared_ptr<T>>
class InfoList : public unordered_map<string, TPtr> {
public:
	InfoList<T> *parent;
	InfoList(InfoList<T> *parent = nullptr) : parent(parent) {};
	TPtr operator[](string name) const {
		TPtr ret = local(name);
		return ret ? ret : parent ? (*parent)[name] : nullptr;
	}
	TPtr local(string name) const {
		auto p = (*this).find(name);
		if (p != this->end()) {
			return p->second;
		}
		return nullptr;
	}
	void add(TPtr obj) {
		this->emplace(obj->name, obj);
	}

	InfoList<T>& operator<<(TPtr obj) {
		add(obj);
		return *this;
	}
};
