#ifndef ERROR_HEADER
#define ERROR_HEADER
#include "Absyn.h"
#include "Info.h"
#include <string>
#include <stdexcept>
#include <memory>
using namespace std;

class ParseError : std::runtime_error {
protected:
	string msg;
	int line;
	ParseError() : runtime_error("ParseError"), line(-1) {}
public:
	ParseError(string reason, int line = -1) : runtime_error("ParseError"), line(line) {}
	virtual const char * what() const _GLIBCXX_TXN_SAFE_DYN _GLIBCXX_NOTHROW { return msg.data(); }
};

class PIdent;

class RedefinedError : public ParseError {
public:
	RedefinedError(PIdent *ident, VarInfoPtr orig);
};

class UndefinedError : public ParseError {
public:
	UndefinedError(PIdent *ident);
};

class InvalidTypeError : public ParseError {
public:
	InvalidTypeError(int lineno, Type &expected, vector<shared_ptr<Type>> received, Expr *expr = NULL);
};

#endif